﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
#Event: Click (ReturnValue as Object)
#Event: LongClick (ReturnValue as Object) 
#Event: Menu_Open
#Event: Menu_Closed
Sub Class_Globals
	
	
	Private mTextSize As Int = 18
	Private mDark As Boolean = False
	Private mMenuTextColor As Int = Colors.Black 
	Private mMenuAnimationDuration As Int = 300
	Private mMenuItemBackColor As Int = Colors.Transparent 
	Private mAutoScaleRate As Float = 0
	Private mUseSymbols As Boolean = True
	Private mTypeFace As Typeface = Typeface.DEFAULT

	
	Private mScale As Float = 1
	Private mActivity As Activity
	Private mModule As Object
	Private mSubActionBar As String 
	Private mLeft, mTop As Int 
	Private inMenuAnimation,outMenuAnimation As Animation
	Private pnlMenu,pnlTransparent  As Panel
	Private lsvMenu As ListView 

End Sub
#Region Settings
'Color of the Items in the Menu
Public Sub getMenuItemBackColor As Int
	Return mMenuItemBackColor
End Sub
Public Sub setMenuItemBackColor (MenuItemBackColor As Int)
	mMenuItemBackColor = MenuItemBackColor
	lsvMenu.Color = mMenuItemBackColor
End Sub
'Returns if Menu is visible
Public Sub isVisible As Boolean
	Return pnlMenu.Visible 
End Sub
'Sets if you want to display Symbols
'<B>Has to be set bevore Items are added </B>
Public Sub setUseSymbols (UseSymbols As Boolean)
	mUseSymbols =UseSymbols
End Sub
Public Sub getUseSymbols As Boolean 
	Return mUseSymbols
End Sub
'Sets the Scale. Use the same ratio as in your DesignerScript (AutoScaleRate)
'<B>Has to be called before Items are added</B>
'Use 0 to disable
Public Sub getAutoScaleRate As Int 
	Return mAutoScaleRate
End Sub
Public Sub setAutoScaleRate (AutoScaleRate As Int)
	mAutoScaleRate = AutoScaleRate 
	
		Dim delta As Float 
		delta = ((100%x + 100%y) / (320dip + 430dip) - 1)
		mScale = 1 + mAutoScaleRate * delta

	lsvMenu.TwoLinesAndBitmap.Label.TextSize = mTextSize  * mScale
	lsvMenu.SingleLineLayout.Label.TextSize = mTextSize  * mScale
	End Sub
'TextSize of the Menu Items 
Public Sub getTextSize As Int 
	Return mTextSize
End Sub
Public Sub setTextSize (TextSize As Int)
	mTextSize = TextSize 
	lsvMenu.TwoLinesAndBitmap.Label.TextSize = mTextSize  * mScale
	lsvMenu.SingleLineLayout.Label.TextSize = mTextSize  * mScale
End Sub
'Loads different drawables for the Dark-Theme
'<B>Has to be called before you set custom colors and add items!</B>
Public Sub getDarkTheme As Boolean
	Return mDark
End Sub
Public Sub setDarkTheme (DarkTheme As Boolean)
	mDark = DarkTheme
	
	If mDark = True Then
		SetNinePatchDrawable(pnlMenu,"ahaab_menu_dark")
		setTextColor(Colors.White)
	Else
		SetNinePatchDrawable(pnlMenu,"ahaab_menu")
		setTextColor(Colors.Black ) 
	End If
End Sub
'Duration of the Menu Animation in Milliseconds
Public Sub getMenuAnimationDuration As Int 
	Return mMenuAnimationDuration
End Sub
Public Sub setMenuAnimationDuration (MenuAnimationDuration As Int)
	mMenuAnimationDuration = MenuAnimationDuration
	inMenuAnimation.Duration = mMenuAnimationDuration
	outMenuAnimation.Duration = mMenuAnimationDuration
End Sub
'TextColor of the Menu Entries
Public Sub getTextColor As Int 
	Return mMenuTextColor
End Sub
Public Sub setTextColor (TextColor As Int)
	mMenuTextColor = TextColor
	lsvMenu.TwoLinesAndBitmap.Label.TextColor = mMenuTextColor
	lsvMenu.SingleLineLayout.Label.TextColor = mMenuTextColor
End Sub
'Returns the ListView of the Menu
Public Sub MenuListView As  ListView
	Return lsvMenu 
End Sub
'TypeFace of the Menu
Public Sub setTypeFace (NewTypeFace As Typeface)
	mTypeFace =NewTypeFace
	lsvMenu.TwoLinesAndBitmap.Label.Typeface = mTypeFace
	lsvMenu.SingleLineLayout.Label.Typeface = mTypeFace
End Sub
Public Sub getTypeFace As Typeface
	Return mTypeFace
End Sub
#End Region 

'Initialized the Menu
'Activity: Activity, Module=Me, Eventname (e.g. Menu), X,Y Position where the menu should open
Public Sub Initialize(Activity As Activity, Module As Object, EventName As String, X As Int, Y As Int )

	mActivity = Activity
	mModule = Module
	mSubActionBar = EventName
	mLeft = X
	mTop = Y
	
	pnlMenu.Initialize("")
	pnlMenu.Visible = False
	pnlTransparent.Initialize("CatchClick")
	pnlTransparent.Visible = False
	mActivity.AddView (pnlTransparent,0dip,0dip,100%x,100%y)
	
	If mLeft +200dip >= 100%x Then mLeft = (100%x - 200dip) +5dip
	If mTop +72dip >= 100%y Then mTop = 100%y - 72dip
	
	mActivity.AddView(pnlMenu,mLeft,mTop,200dip,72dip)
	'mActivity.AddView(pnlMenu,pnlActionBar.Width -200dip,mHeight-16dip,200dip * mScale,200dip)
	
	
	lsvMenu.Initialize ("Menu")
	lsvMenu.TwoLinesAndBitmap.SecondLabel.Visible = False
	lsvMenu.TwoLinesAndBitmap.ItemHeight = 48dip
	lsvMenu.TwoLinesAndBitmap.Label.Gravity = Gravity.CENTER_VERTICAL
	lsvMenu.TwoLinesAndBitmap.Label.Height = lsvMenu.TwoLinesAndBitmap.ItemHeight
	lsvMenu.TwoLinesAndBitmap.Label.Top = 0
	lsvMenu.TwoLinesAndBitmap.ImageView.SetLayout(13dip, 13dip, 24dip, 24dip)
	lsvMenu.TwoLinesAndBitmap.Label.TextSize = mTextSize  * mScale
	lsvMenu.TwoLinesAndBitmap.Label.TextColor = mMenuTextColor

	lsvMenu.SingleLineLayout.ItemHeight = 48dip
	lsvMenu.SingleLineLayout.Label.Gravity = Gravity.CENTER_VERTICAL
	lsvMenu.SingleLineLayout.Label.Height = lsvMenu.SingleLineLayout.ItemHeight
	lsvMenu.SingleLineLayout.Label.Top = 0
	lsvMenu.SingleLineLayout.Label.TextSize = mTextSize  * mScale
	lsvMenu.SingleLineLayout.Label.TextColor = mMenuTextColor

	pnlMenu.AddView(lsvMenu,12dip,12dip,pnlMenu.Width-12dip,pnlMenu.Height-12dip)
	inMenuAnimation.InitializeAlpha("",0,1)
	outMenuAnimation.InitializeAlpha("",1,0)
	inMenuAnimation.Duration = mMenuAnimationDuration
	outMenuAnimation.Duration = mMenuAnimationDuration

End Sub
'Adds a Menu Item. Pass NULL as image if you don't want one
Public Sub AddMenuItem(Text As String, image As Bitmap,ReturnValue As Object )
	Dim AddSpacing As Int = 0
	If mUseSymbols = True Then AddSpacing = 110dip
	Dim C As Canvas
	C.Initialize(pnlMenu)
	Dim X As Int
	X = C.MeasureStringWidth( Text, Typeface.DEFAULT, mTextSize) '*1dip'+5dip '* 1dip +5dip *1dip
	If X > lsvMenu.Width - AddSpacing Then
		Dim tmpwidth As Int = pnlMenu.Width
		pnlMenu.Width = X+ AddSpacing  
		pnlMenu.Left = pnlMenu.Left - (pnlMenu.Width - tmpwidth) +3dip
		lsvMenu.Width = pnlMenu.Width-12dip
	End If
	
	If mUseSymbols = True Then
		If Not(image.IsInitialized) Then
			lsvMenu.AddTwoLinesAndBitmap2(Text, "", Null, ReturnValue)
		Else
			lsvMenu.AddTwoLinesAndBitmap2(Text, "", image, ReturnValue)
		End If
	Else
		lsvMenu.AddSingleLine2(Text, ReturnValue)
	End If
	
	pnlMenu.Height = lsvMenu.Size * 49dip + 24dip
	lsvMenu.Height = lsvMenu.Size * 49dip 
	
	If pnlMenu.Height > 100%y - (pnlMenu.Top )Then 
		pnlMenu.Height = 100%y - (pnlMenu.Top )
		lsvMenu.Height = pnlMenu.Height -24dip
	End If
End Sub
Private Sub Menu_ItemClick (Position As Int, Value As Object)
	TriggerMenu
	If SubExists(mModule, mSubActionBar & "_Click") Then
		CallSub2(mModule, mSubActionBar & "_Click", Value)
	End If
End Sub
Private Sub Menu_ItemLongClick (Position As Int, Value As Object)
	TriggerMenu
	If SubExists(mModule, mSubActionBar & "_LongClick") Then
		CallSub2(mModule, mSubActionBar & "_LongClick", Value)
	End If	
End Sub
'Repositions the Menu
Public Sub RepostitionMenu (X As Int, Y As Int)
	mLeft = X
	mTop = Y

	If mLeft + pnlMenu.Width  >= 100%x Then mLeft = 100%x - pnlMenu.Width
	If mTop + pnlMenu.Height  >= 100%y Then mTop = 100%y - 72dip
	
	pnlMenu.Top = mTop
	pnlMenu.Left = mLeft
End Sub
'Opens the Menu
Public Sub OpenMenu
		If mDark = True Then
		SetNinePatchDrawable(pnlMenu,"ahaab_menu_dark")
	Else
		SetNinePatchDrawable(pnlMenu,"ahaab_menu")
	End If

	pnlMenu.Visible = True
	pnlTransparent.Visible = True
	pnlTransparent.BringToFront
	pnlMenu.BringToFront 
	inMenuAnimation.Start(pnlMenu)
	If SubExists(mModule,mSubActionBar &  "_Menu_Open") Then CallSub(mModule, mSubActionBar & "_Menu_Open")
End Sub
'Closes the Menu
Public Sub CloseMenu
	pnlMenu.Visible = False
	pnlTransparent.Visible = False
	outMenuAnimation.Start(pnlMenu)
	If SubExists(mModule,mSubActionBar &  "_Menu_Closed") Then CallSub(mModule, mSubActionBar & "_Menu_Closed")
End Sub
'Opens/closes the Menu
Public Sub TriggerMenu
	If pnlMenu.Visible = True Then
		CloseMenu
	Else
		OpenMenu
	End If
End Sub
'Filters the Back & Menu Key
'Usage:
'<code>Sub Activity_KeyPress (KeyCode As Int) As Boolean
'	Return ActionBar.Keypress(KeyCode)
'End Sub</code>
#Region HelperSubs
Public Sub Keypress(Keycode As Int)As Boolean
	If Keycode = KeyCodes.KEYCODE_BACK OR Keycode = KeyCodes.KEYCODE_MENU Then
		If isVisible Then
			CloseMenu 
			Return True
		Else
			Return False
		End If
	End If	
	Return False
End Sub
Private Sub CatchClick_Click
	TriggerMenu
End Sub
Private Sub SetNinePatchDrawable(Control As View, ImageName As String)
    Try
		Dim R As Reflector
	    Dim package As String
	    Dim id As Int
	    package = R.GetStaticField("anywheresoftware.b4a.BA", "packageName")
	    id = R.GetStaticField(package & ".R$drawable", ImageName)
	    R.Target = R.GetContext
	    R.Target = R.RunMethod("getResources")
	    Control.Background = R.RunMethod2("getDrawable", id, "java.lang.int")
	Catch
		Dim bg As ColorDrawable 
		bg.Initialize(Colors.Gray,0dip)
		Control.Background = bg 
		'ToastMessageShow("Drawable " & ImageName & " is missing." & CRLF & "Did you copy it to the Objects/res/drawable/ folder?" & CRLF & CRLF & "Don't forget to set it to read only",False)
	End Try
End Sub
#End Region 